TIMEAGO

Use this function to calculate the elapsed time between two moments.

Syntax Argument Description time1 (Required) - shows the starting date and time from which we need to calculate elapsed time. You can input the TIMEAGO function from the above code directly into a cell, or you can use the setFormula method to apply the formula. Usage notes The TIMEAGO function is meant to make it easier to calculate the time passed from a starting point to a current point in time It's usage is mostly common on project management. You can use the TIMEAGO function if you want to show something more relative to a specific time rather than a straightforward date. Benefits This function allows you to have a calculation of the interval passed between 2 moments without having to create complicated custom functions and methods.
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById('ss')); initSpread(spread); }; function initSpread(spread) { var sheet = spread.getActiveSheet(); //this should be a SpreadJS Function not a custom one function TimeAgoFunction() { this.name = "TIMEAGO"; this.maxArgs = 1; this.minArgs = 1; } TimeAgoFunction.prototype = new GC.Spread.CalcEngine.Functions.Function(); TimeAgoFunction.prototype.evaluate = function(time1) { switch (typeof time1) { case 'number': break; case 'string': time1 = +new Date(time1); break; case 'object': if (time1.constructor === Date) time1 = time1.getTime(); break; default: time1 = +new Date(); } var time2 = +new Date(); if(time1 == time2){ return "just now"; } var isFuture = (time2 < time1); var seconds = ( isFuture ? time1 - time2 : time2 - time1) / 1000; var interval = seconds / 31536000; if (interval >= 1) { var years = Math.floor(interval); return isFuture ? "in " + (years <= 1 ? "one year" : years + " years") : years <= 1 ? "one year ago" : years + " years ago"; } interval = seconds / 2592000; if (interval >= 1) { var months = Math.floor(interval); return isFuture ? "in " + (months <= 1 ? "one month" : months + " months") : months <= 1 ? "one month ago" : months + " months ago"; } interval = seconds / 86400; if (interval >= 1) { var days = Math.floor(interval); return isFuture ? "in " + (days <= 1 ? "tomorrow" : days + " days") : days <= 1 ? "yesterday" : days + " days ago"; } interval = seconds / 3600; if (interval > 1) { var hours = Math.floor(interval); return isFuture ? "in " + (hours <= 1 ? "an hour" : hours + " hours") : hours <= 1 ? "an hour ago" : hours + " hours ago"; } interval = seconds / 60; if (interval > 1) { var minutes = Math.floor(interval); return isFuture ? "in " + (minutes <= 1 ? "a minute" : minutes + " minutes") : minutes <= 1 ? "a minute ago" : minutes + " minutes ago"; } seconds = Math.floor(seconds); return isFuture ? "in " + (seconds <= 1 ? "one second" : seconds + " seconds") : seconds <= 1 ? "one second ago" : seconds + " seconds ago"; }; var timeAgo = new TimeAgoFunction(); sheet.addCustomFunction(timeAgo); // spread.fromJSON(data[0]); sheet.setColumnWidth(0, 200); sheet.setColumnWidth(1, 200); sheet.setColumnWidth(2, 150); sheet.setValue(0,0, 'Date'); sheet.setValue(0,1, 'Formula'); sheet.setValue(0,2, 'Result'); sheet.setFormula(1,0, 'TODAY()'); sheet.setValue(1,1, '=TIMEAGO(A2)'); sheet.setFormula(1,2, 'TIMEAGO(A2)'); sheet.setValue(2,0, new Date('2020-01-20')); sheet.setValue(2,1, '=TIMEAGO(A3)'); sheet.setFormula(2,2, 'TIMEAGO(A3)'); sheet.setValue(3,0, new Date('2021-02-10')); sheet.setValue(3,1, '=TIMEAGO(A4)'); sheet.setFormula(3,2, 'TIMEAGO(A4)'); sheet.setValue(4,0, new Date('2021-11-29 17:12:00')); sheet.setValue(4,1, '=TIMEAGO(A5)'); sheet.setFormula(4,2, 'TIMEAGO(A5)'); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

Syntax
Argument
Description
time1
(Required) - shows the starting date and time from which we need to calculate elapsed time.
You can input the TIMEAGO function from the above code directly into a cell, or you can use the setFormula method to apply the formula.
Usage notes
The TIMEAGO function is meant to make it easier to calculate the time passed from a starting point to a current point in time
It's usage is mostly common on project management.
You can use the TIMEAGO function if you want to show something more relative to a specific time rather than a straightforward date.
Benefits
This function allows you to have a calculation of the interval passed between 2 moments without having to create complicated custom functions and methods.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet :autoGenerateColumns='autoGenerateColumns'>
</gc-worksheet>
</gc-spread-sheets>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
let initSpread = function (spread) {
spreadRef.value = spread;
//custom function - should be a genuine one
function TimeAgoFunction() {
this.name = "TIMEAGO";
this.maxArgs = 1;
this.minArgs = 1;
}
TimeAgoFunction.prototype = new GC.Spread.CalcEngine.Functions.Function();
TimeAgoFunction.prototype.evaluate = function (time1) {
switch (typeof time1) {
case 'number':
break;
case 'string':
time1 = +new Date(time1);
break;
case 'object':
if (time1.constructor === Date) time1 = time1.getTime();
break;
default:
time1 = +new Date();
}
let time2 = +new Date();
if (time1 == time2) {
return "just now";
}
let isFuture = (time2 < time1);
let seconds = (isFuture ? time1 - time2 : time2 - time1) / 1000;
let interval = seconds / 31536000;
if (interval >= 1) {
let years = Math.floor(interval);
return isFuture ? "in " + (years <= 1 ? "one year" : years + " years")
: years <= 1 ? "one year ago" : years + " years ago";
}
interval = seconds / 2592000;
if (interval >= 1) {
let months = Math.floor(interval);
return isFuture ? "in " + (months <= 1 ? "one month" : months + " months") : months <= 1 ? "one month ago" : months + " months ago";
}
interval = seconds / 86400;
if (interval >= 1) {
let days = Math.floor(interval);
return isFuture ? "in " + (days <= 1 ? "tomorrow" : days + " days")
: days <= 1 ? "yesterday" : days + " days ago";
}
interval = seconds / 3600;
if (interval > 1) {
let hours = Math.floor(interval);
return isFuture ? "in " + (hours <= 1 ? "an hour" : hours + " hours")
: hours <= 1 ? "an hour ago" : hours + " hours ago";
}
interval = seconds / 60;
if (interval > 1) {
let minutes = Math.floor(interval);
return isFuture ? "in " + (minutes <= 1 ? "a minute" : minutes + " minutes")
: minutes <= 1 ? "a minute ago" : minutes + " minutes ago";
}
seconds = Math.floor(seconds);
return isFuture ? "in " + (seconds <= 1 ? "one second" : seconds + " seconds")
: seconds <= 1 ? "one second ago" : seconds + " seconds ago";
};
spread.suspendPaint();
let sheet = spread.getSheet(0);
sheet.addCustomFunction(new TimeAgoFunction());
sheet.setColumnWidth(0, 200);
sheet.setColumnWidth(1, 200);
sheet.setColumnWidth(2, 150);
sheet.setValue(0, 0, 'Date');
sheet.setValue(0, 1, 'Formula');
sheet.setValue(0, 2, 'Result');
sheet.setFormula(1, 0, 'TODAY()');
sheet.setValue(1, 1, '=TIMEAGO(A2)');
sheet.setFormula(1, 2, 'TIMEAGO(A2)');
sheet.setValue(2, 0, new Date('2020-01-20'));
sheet.setValue(2, 1, '=TIMEAGO(A3)');
sheet.setFormula(2, 2, 'TIMEAGO(A3)');
sheet.setValue(3, 0, new Date('2021-02-10'));
sheet.setValue(3, 1, '=TIMEAGO(A4)');
sheet.setFormula(3, 2, 'TIMEAGO(A4)');
sheet.setValue(4, 0, new Date('2021-11-29 17:12:00'));
sheet.setValue(4, 1, '=TIMEAGO(A5)');
sheet.setFormula(4, 2, 'TIMEAGO(A5)');
spread.resumePaint();
}
let initExcel2010 = function (spread) {
let spreadNS = GC.Spread.Sheets;
let sheet = spread.getSheet(1);
sheet.name("Excel 2010 Functions");
sheet.setColumnWidth(0, 200);
sheet.setColumnWidth(1, 400);
sheet.setColumnWidth(2, 80);
sheet.getRange(-1, 0, -1, 1).wordWrap(true);
sheet.getRange(-1, 1, -1, 1).wordWrap(true);
let data = [
["Formula", "Description", "Result"],
["=BETA.DIST(2,8,10,TRUE,1,3)", "Cumulative beta probability density function"],
["=BETA.DIST(2,8,10,FALSE,1,3)", "Beta probability density function"],
["=CEILING.PRECISE(4.3)", "Rounds 4.3 up to the nearest multiple of 1."],
["=CEILING.PRECISE(-4.3)", "Rounds -4.3 up to the nearest multiple of 1. Rounds toward 0 because the number is negative."],
["=CEILING.PRECISE(4.3, 2)", "Rounds 4.3 up to the nearest multiple of 2."],
["=CHISQ.DIST(0.5,1,TRUE)", "The chi-squared distribution for 0.5, returned as the cumulative distribution function, using 1 degree of freedom."],
["=CHISQ.DIST(2,3,FALSE)", "The chi-squared distribution for 2, returned as the probability density function, using 3 degrees of freedom."],
["=CHISQ.INV(0.93,1)", "Inverse of the left-tailed probability of the chi-squared distribution for 0.93, using 1 degree of freedom."],
["=CHISQ.INV(0.6,2)", "Inverse of the left-tailed probability of the chi-squared distribution for 0.6, using 2 degrees of freedom."],
["=CONFIDENCE.T(0.05,1,50)", "Confidence interval for the mean of a population based on a sample size of 50, with a 5% significance level and a standard deviation of 1. This is based on a Student's t-distribution."],
["=COVARIANCE.S({2,4,8},{5,8,11})", "Sample covariance for the data points entered as an array in the function."],
["=ERF.PRECISE(0.74500)", "Error function integrated between 0 and 0.74500 (0.707929)"],
["=ERFC.PRECISE(0.74500)", "Complementary ERF function of 0.74500."],
["=F.DIST(15.2069,6,4,TRUE)", "F probability using the cumulative distribution function (TRUE cumulative argument)."],
["=F.DIST(15.2069,6,4,FALSE)", "F probability using the probability density function (FALSE cumulative argument)."],
["=F.INV(0.01,6,4)", "Inverse of the F probability distribution."],
["=FLOOR.PRECISE(-3.2)", "Rounds -3.2 down to the nearest multiple of -1"],
["=FLOOR.PRECISE(3.2)", "Rounds 3.2 down to the nearest multiple of 1"],
["=FLOOR.PRECISE(3.2, 2)", "Rounds 3.2 down to the nearest multiple of 2"],
["=GAMMALN.PRECISE(4)", "Natural logarithm of the gamma function at 4"],
["=HYPGEOM.DIST(1,4,8,20,TRUE)", "Cumulative hypergeometric distribution function."],
["=HYPGEOM.DIST(1,4,8,20,FALSE)", "Probability hypergeometric distribution function."],
["=ISO.CEILING(4.3)", "Rounds 4.3 up to nearest multiple of 1"],
["=ISO.CEILING(-4.3)", "Rounds -4.3 up to nearest multiple of 1"],
["=ISO.CEILING(4.3, 2)", "Rounds 4.3 up to the nearest multiple of 2"],
["=LOGNORM.DIST(4,3.5,1.2,TRUE)", "Cumulative lognormal distribution at 4."],
["=LOGNORM.DIST(4,3.5,1.2,FALSE)", "Probability lognormal distribution at 4."],
["=NEGBINOM.DIST(10,5,0.25,TRUE)", "Cumulative negative binomial distribution."],
["=NEGBINOM.DIST(10,5,0.25,FALSE)", "Probability negative binomial distribution."],
["=NETWORKDAYS.INTL(DATE(2006,1,1),DATE(2006,1,31))", "Results in 22 future workdays. Subtracts 9 nonworking weekend days (5 Saturdays and 4 Sundays) from the 31 total days between the two dates. By default, Saturday and Sunday are considered non-working days."],
["=NETWORKDAYS.INTL(DATE(2006,2,28),DATE(2006,1,31))", "Results in -21, which is 21 workdays in the past."],
["=NETWORKDAYS.INTL(DATE(2006,1,1),DATE(2006,2,1),7,{\"2006/1/2\",\"2006/1/16\"})", "Results in 22 future workdays by sutracting 10 nonworking days (4 Fridays, 4 Saturdays, 2 Holidays) from the 32 days between Jan 1 2006 and Feb 1 2006. Uses the 7 argument for weekend, which is Friday and Saturday. There are also two holidays in this time period."],
["=NETWORKDAYS.INTL(DATE(2006,1,1),DATE(2006,2,1),\"0010001\",{\"2006/1/2\",\"2006/1/16\"})", "Results in 20 future workdays. Same time period as above, but with Sunday and Wednesday as weekend days."],
["=NORM.S.DIST(1.333333,TRUE)", "Normal cumulative distribution function at 1.333333."],
["=NORM.S.DIST(1.333333,FALSE)", "Normal probability distribution function at 1.333333."],
["=PERCENTRANK.EXC({1,2,3,4,6,6,7,8,9}, 7)", "Returns the rank of the value 7 from the array."],
["=PERCENTRANK.EXC({1,2,3,4,6,6,7,8,9}, 5.43)", "Returns the rank of the value 5.43 in the array."],
["=PERCENTRANK.EXC({1,2,3,4,6,6,7,8,9}, 5.43, 1)", "Returns the rank of the value 5.43 in the array, displaying only 1 significant digit in the result (the default is 3)."],
["=PERCENTILE.EXC({1,2,3,4,5,6}, 0.25)", "Interpolates when the value for the specified percentile lies between two values in the array."],
["=QUARTILE.EXC({1,2,3,4,5,6,7,8,9,10,11},1)", "Locates the position of the first quartile (3)."],
["=QUARTILE.EXC({1,2,3,4,5,6,7,8,9,10,11},3)", "Locates the position of the third quartile (9)."],
["=RANK.AVG(95, {89, 88, 92, 101, 94, 97, 95})", "Finds the rank (the position) of the value 95 in the array (descending order). In this case, 95 was the 3rd one in descending order."],
["=RANK.AVG(95, {89, 88, 92, 101, 94, 97, 95}, 1)", "Finds the rank (the position) of the value 95 in the array (ascending order). In this case, 95 was the 5th one in ascending order."],
["=T.DIST(60,1,TRUE)", "Student's left-tailed t-distribution for 60, returned as the cumulative distribution function, using 1 degree of freedom."],
["=T.DIST(8,3,FALSE)", "Student's left-tailed t-distribution for 8, returned as the probability density function, using 3 degrees of freedom."],
["=T.INV(0.05464,60)", "The t-value of the Student's t-distribution based on specified arguments."],
["=WORKDAY.INTL(DATE(2012,1,1),30,0)", "Using a 0 for the Weekend argument results in a #NUM! error."],
["=WORKDAY.INTL(DATE(2012,1,1),90,11)", "Finds the date 90 workdays from 1/1/2012, counting only Sundays as a weekend day (Weekend argument is 11)."],
["=TEXT(WORKDAY.INTL(DATE(2012,1,1),30,17), \"m/dd/yyyy\")", "Uses the TEXT function to format the resulting serial number (40944) in a \"m/dd/yyyy\" format. Finds the date 30 workdays from 1/1/2012, counting only Saturdays as a weekend day (Weekend argument is 17)."]
];
sheet.setArray(0, 0, data, false);
let r, len, i;
for (r = 1, len = data.length; r < len; r++) {
sheet.setFormula(r, 2, data[r][0]);
}
let arrayFormulaData = [
["=MODE.MULT({1,2,3,4,3,2,1,2,1,3})", "The formula must be entered as an array formula. It returns 1, 2, and 3 as the modes because they each appear 3 times. If the formula is not entered as an array formula, the single result is 1.", 3]
];
for (i = 0, len = arrayFormulaData.length; i < len; i++) {
let cur = arrayFormulaData[i],
rows = cur[2],
cols = cur[3] || 1;
sheet.addSpan(r, 0, rows, 1);
sheet.setValue(r, 0, cur[0]);
sheet.addSpan(r, 1, rows, 1);
sheet.setValue(r, 1, cur[1]);
sheet.setArrayFormula(r, 2, rows, cols, cur[0]);
r += rows;
}
for (i = 1; i < r; i++) {
sheet.autoFitRow(i);
}
sheet.getRange(-1, 2, -1, 1).formatter(".######");
sheet.setFormatter(48, 2, "M/d/yyyy");
let table = sheet.tables.add("FunctionTable", 0, 0, 50, 3, spreadNS.Tables.TableThemes.medium9);
table.rowFilter().filterButtonVisible(false);
// Array formula with merge cells, set style like above table rows
let rowStyle = sheet.getActualStyle(48, 0);
sheet.getRange(50, 0, 3, 3).backColor(rowStyle.backColor);
sheet.getRange(49, 0, 4, 3).setBorder(rowStyle.borderBottom, {
all: true
});
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
#switchAutoMergeMode {
margin: 10px 0px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Syntax
Argument
Description
time1
(Required) - shows the starting date and time from which we need to calculate elapsed time.
You can input the TIMEAGO function from the above code directly into a cell, or you can use the setFormula method to apply the formula.
Usage notes
The TIMEAGO function is meant to make it easier to calculate the time passed from a starting point to a current point in time
It's usage is mostly common on project management.
You can use the TIMEAGO function if you want to show something more relative to a specific time rather than a straightforward date.
Benefits
This function allows you to have a calculation of the interval passed between 2 moments without having to create complicated custom functions and methods.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
class TimeAgoFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("TIMEAGO", 1, 1);
}
evaluate (time1: any) {
switch (typeof time1) {
case 'number':
break;
case 'string':
time1 = +new Date(time1);
break;
case 'object':
if (time1.constructor === Date) time1 = time1.getTime();
break;
default:
time1 = +new Date();
}
let time2 = +new Date();
if(time1 == time2){
return "just now";
}
var isFuture = (time2 < time1);
var seconds = ( isFuture ? time1 - time2 : time2 - time1) / 1000;
var interval = seconds / 31536000;
if (interval >= 1) {
var years = Math.floor(interval);
return isFuture ? "in " + (years <= 1 ? "one year" : years + " years")
: years <= 1 ? "one year ago" : years + " years ago";
}
interval = seconds / 2592000;
if (interval >= 1) {
var months = Math.floor(interval);
return isFuture ? "in " + (months <= 1 ? "one month" : months + " months") : months <= 1 ? "one month ago" : months + " months ago";
}
interval = seconds / 86400;
if (interval >= 1) {
var days = Math.floor(interval);
return isFuture ? "in " + (days <= 1 ? "tomorrow" : days + " days")
: days <= 1 ? "yesterday" : days + " days ago";
}
interval = seconds / 3600;
if (interval > 1) {
var hours = Math.floor(interval);
return isFuture ? "in " + (hours <= 1 ? "an hour" : hours + " hours")
: hours <= 1 ? "an hour ago" : hours + " hours ago";
}
interval = seconds / 60;
if (interval > 1) {
var minutes = Math.floor(interval);
return isFuture ? "in " + (minutes <= 1 ? "a minute" : minutes + " minutes")
: minutes <= 1 ? "a minute ago" : minutes + " minutes ago";
}
seconds = Math.floor(seconds);
return isFuture ? "in " + (seconds <= 1 ? "one second" : seconds + " seconds")
: seconds <= 1 ? "one second ago" : seconds + " seconds ago";
}
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = true;
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
timeAgoFun : any;
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
this.timeAgoFun = new TimeAgoFunction();
let spread = this.spread;
spread.suspendPaint();
let sheet = spread.getSheet(0);
sheet.addCustomFunction(this.timeAgoFun);
sheet.setColumnWidth(0, 200);
sheet.setColumnWidth(1, 200);
sheet.setColumnWidth(2, 150);
sheet.setValue(0,0, 'Date');
sheet.setValue(0,1, 'Formula');
sheet.setValue(0,2, 'Result');
sheet.setFormula(1,0, 'TODAY()');
sheet.setValue(1,1, '=TIMEAGO(A2)');
sheet.setFormula(1,2, 'TIMEAGO(A2)');
sheet.setValue(2,0, new Date('2020-01-20'));
sheet.setValue(2,1, '=TIMEAGO(A3)');
sheet.setFormula(2,2, 'TIMEAGO(A3)');
sheet.setValue(3,0, new Date('2021-02-10'));
sheet.setValue(3,1, '=TIMEAGO(A4)');
sheet.setFormula(3,2, 'TIMEAGO(A4)');
sheet.setValue(4,0, new Date('2021-11-29 17:12:00'));
sheet.setValue(4,1, '=TIMEAGO(A5)');
sheet.setFormula(4,2, 'TIMEAGO(A5)');
spread.resumePaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet [autoGenerateColumns]='autoGenerateColumns'>
</gc-worksheet>
</gc-spread-sheets>
</div>
export function getData(){
var data = [{
"version":"14.0.5",
"sheetCount":2,
"tabStripRatio":0.6,
"customList":[
],
"activeSheetIndex":0,
"sheets":{
"Sheet1":{
"name":"Sheet1",
"isSelected":true,
"rowCount":100,
"columnCount":100,
"activeRow":15,
"activeCol":3,
"theme":{
"name":"Office",
"themeColor":{
"name":"Office",
"background1":{
"a":255,
"r":255,
"g":255,
"b":255
},
"background2":{
"a":255,
"r":231,
"g":230,
"b":230
},
"text1":{
"a":255,
"r":0,
"g":0,
"b":0
},
"text2":{
"a":255,
"r":68,
"g":84,
"b":106
},
"accent1":{
"a":255,
"r":68,
"g":114,
"b":196
},
"accent2":{
"a":255,
"r":237,
"g":125,
"b":49
},
"accent3":{
"a":255,
"r":165,
"g":165,
"b":165
},
"accent4":{
"a":255,
"r":255,
"g":192,
"b":0
},
"accent5":{
"a":255,
"r":91,
"g":155,
"b":213
},
"accent6":{
"a":255,
"r":112,
"g":173,
"b":71
},
"hyperlink":{
"a":255,
"r":5,
"g":99,
"b":193
},
"followedHyperlink":{
"a":255,
"r":149,
"g":79,
"b":114
}
},
"headingFont":"Calibri Light",
"bodyFont":"Calibri"
},
"data":{
"dataTable":{
"0":{
"0":{
"value":"Date"
},
"1":{
"value":"Formula"
},
"2":{
"value":"Result"
}
},
"1":{
"0":{
"value":"/OADate(43842)/",
"style":"__builtInTableStyle0__builtInStyle5"
},
"1":{
"value":"=TIMEAGO(A3;A5)",
"style":"__builtInTableStyle1__builtInStyle6"
},
"2":{
"value":{
"_calcError":"#NAME?",
"_code":29
},
"style":"__builtInTableStyle1__builtInStyle6",
"formula":"TIMEAGO(A3,A5)"
}
},
"2":{
"0":{
"value":43842.125,
"style":"__builtInTableStyle2__builtInStyle4"
},
"1":{
"value":"=TIMEAGO(A5)",
"style":"__builtInTableStyle1__builtInStyle6"
},
"2":{
"value":{
"_calcError":"#NAME?",
"_code":29
},
"style":"__builtInTableStyle1__builtInStyle6",
"formula":"TIMEAGO(A5)"
}
},
"3":{
"0":{
"value":"2-Aug-2009",
"style":"__builtInTableStyle3__builtInStyle3"
},
"1":{
"value":"=TIMEAGO(A1)",
"style":"__builtInTableStyle1__builtInStyle6"
},
"2":{
"value":{
"_calcError":"#NAME?",
"_code":29
},
"style":"__builtInTableStyle1__builtInStyle6",
"formula":"TIMEAGO(A1)"
}
},
"4":{
"0":{
"value":"/OADate(47651)/",
"style":"__builtInTableStyle0__builtInStyle5"
},
"1":{
"value":"=TIMEAGO(A5;A6)",
"style":"__builtInTableStyle1__builtInStyle6"
},
"2":{
"value":{
"_calcError":"#NAME?",
"_code":29
},
"style":"__builtInTableStyle1__builtInStyle6",
"formula":"TIMEAGO(A5,A6)"
}
},
"5":{
"0":{
"value":"/OADate(42736)/",
"style":"__builtInTableStyle4__builtInStyle2"
},
"1":{
"value":"=TIMEAGO(A1;A3)",
"style":"__builtInTableStyle1__builtInStyle6"
},
"2":{
"value":{
"_calcError":"#NAME?",
"_code":29
},
"style":"__builtInTableStyle1__builtInStyle6",
"formula":"TIMEAGO(A1,A3)"
}
},
"6":{
"1":{
"value":"=TIMEAGO(A4,A4)",
"style":"__builtInTableStyle1__builtInStyle6"
},
"2":{
"value":{
"_calcError":"#NAME?",
"_code":29
},
"style":"__builtInTableStyle1__builtInStyle6",
"formula":"TIMEAGO(A4;A4)"
}
},
"7":{
"1":{
"value":"=TIMEAGO(A3;A6)",
"style":"__builtInTableStyle1__builtInStyle6"
},
"2":{
"value":{
"_calcError":"#NAME?",
"_code":29
},
"style":"__builtInTableStyle1__builtInStyle6",
"formula":"TIMEAGO(A3;A6)"
}
}
},
"defaultDataNode":{
"style":{
"backColor":null,
"foreColor":"Text 1 0",
"vAlign":2,
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":null,
"locked":true,
"textIndent":0,
"wordWrap":false,
"diagonalDown":null,
"diagonalUp":null
}
}
},
"rowHeaderData":{
"defaultDataNode":{
"style":{
"themeFont":"Body"
}
}
},
"colHeaderData":{
"defaultDataNode":{
"style":{
"themeFont":"Body"
}
}
},
"rows":[
{
"size":19
},
{
"size":19,
"visible":true
},
{
"size":19,
"visible":true
},
{
"size":19,
"visible":true
},
{
"size":19,
"visible":true
},
{
"size":19,
"visible":true
},
{
"size":19,
"visible":true
},
{
"size":19,
"visible":true
}
],
"columns":[
{
"size":184
},
{
"size":237
},
{
"size":245
}
],
"leftCellIndex":0,
"topCellIndex":0,
"selections":{
"0":{
"row":15,
"rowCount":1,
"col":3,
"colCount":1
},
"length":1
},
"defaults":{
"colHeaderRowHeight":20,
"colWidth":64,
"rowHeaderColWidth":40,
"rowHeight":19.2,
"_isExcelDefaultColumnWidth":true
},
"rowOutlines":{
"items":[
]
},
"columnOutlines":{
"items":[
]
},
"cellStates":{
},
"outlineColumnOptions":{
},
"autoMergeRangeInfos":[
],
"tables":[
{
"name":"Table1",
"row":0,
"col":0,
"rowCount":8,
"colCount":3,
"style":{
"buildInName":"Light1"
},
"rowFilter":{
"range":{
"row":1,
"rowCount":7,
"col":0,
"colCount":3
},
"typeName":"HideRowFilter",
"dialogVisibleInfo":{
},
"filterButtonVisibleInfo":{
"0":false,
"1":false,
"2":false
},
"showFilterButton":false
},
"columns":[
{
"id":1,
"name":"Date"
},
{
"id":2,
"name":"Formula"
},
{
"id":3,
"name":"Result"
}
]
}
],
"index":0
}
},
"namedStyles":[
{
"backColor":"Accent 1 80",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"20% - Accent1"
},
{
"backColor":"Accent 2 80",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"20% - Accent2"
},
{
"backColor":"Accent 3 80",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"20% - Accent3"
},
{
"backColor":"Accent 4 80",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"20% - Accent4"
},
{
"backColor":"Accent 5 80",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"20% - Accent5"
},
{
"backColor":"Accent 6 80",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"20% - Accent6"
},
{
"backColor":"Accent 1 60",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"40% - Accent1"
},
{
"backColor":"Accent 2 60",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"40% - Accent2"
},
{
"backColor":"Accent 3 60",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"40% - Accent3"
},
{
"backColor":"Accent 4 60",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"40% - Accent4"
},
{
"backColor":"Accent 5 60",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"40% - Accent5"
},
{
"backColor":"Accent 6 60",
"foreColor":"Text 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"40% - Accent6"
},
{
"backColor":"Accent 1 40",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"60% - Accent1"
},
{
"backColor":"Accent 2 40",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"60% - Accent2"
},
{
"backColor":"Accent 3 40",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"60% - Accent3"
},
{
"backColor":"Accent 4 40",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"60% - Accent4"
},
{
"backColor":"Accent 5 40",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"60% - Accent5"
},
{
"backColor":"Accent 6 40",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"60% - Accent6"
},
{
"backColor":"Accent 1 0",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Accent1"
},
{
"backColor":"Accent 2 0",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Accent2"
},
{
"backColor":"Accent 3 0",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Accent3"
},
{
"backColor":"Accent 4 0",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Accent4"
},
{
"backColor":"Accent 5 0",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Accent5"
},
{
"backColor":"Accent 6 0",
"foreColor":"Background 1 0",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Accent6"
},
{
"backColor":"#ffc7ce",
"foreColor":"#9c0006",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Bad"
},
{
"backColor":"#f2f2f2",
"foreColor":"#fa7d00",
"font":"normal bold 14.7px Calibri",
"themeFont":"Body",
"borderLeft":{
"color":"#7f7f7f",
"style":1
},
"borderTop":{
"color":"#7f7f7f",
"style":1
},
"borderRight":{
"color":"#7f7f7f",
"style":1
},
"borderBottom":{
"color":"#7f7f7f",
"style":1
},
"name":"Calculation",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":"#a5a5a5",
"foreColor":"Background 1 0",
"font":"normal bold 14.7px Calibri",
"themeFont":"Body",
"borderLeft":{
"color":"#3f3f3f",
"style":6
},
"borderTop":{
"color":"#3f3f3f",
"style":6
},
"borderRight":{
"color":"#3f3f3f",
"style":6
},
"borderBottom":{
"color":"#3f3f3f",
"style":6
},
"name":"Check Cell",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"formatter":"_(* #,##0.00_);_(* (#,##0.00);_(* \"-\"??_);_(@_)",
"name":"Comma"
},
{
"backColor":null,
"formatter":"_(* #,##0_);_(* (#,##0);_(* \"-\"_);_(@_)",
"name":"Comma [0]"
},
{
"backColor":null,
"formatter":"_(\"$\"* #,##0.00_);_(\"$\"* (#,##0.00);_(\"$\"* \"-\"??_);_(@_)",
"name":"Currency"
},
{
"backColor":null,
"formatter":"_(\"$\"* #,##0_);_(\"$\"* (#,##0);_(\"$\"* \"-\"_);_(@_)",
"name":"Currency [0]"
},
{
"backColor":null,
"foreColor":"#7f7f7f",
"font":"italic normal 14.7px Calibri",
"themeFont":"Body",
"name":"Explanatory Text"
},
{
"backColor":"#c6efce",
"foreColor":"#006100",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Good"
},
{
"backColor":null,
"foreColor":"Text 2 0",
"font":"normal bold 20px Calibri",
"themeFont":"Body",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":{
"color":"Accent 1 0",
"style":5
},
"name":"Heading 1",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"Text 2 0",
"font":"normal bold 17.3px Calibri",
"themeFont":"Body",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":{
"color":"Accent 1 50",
"style":5
},
"name":"Heading 2",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"Text 2 0",
"font":"normal bold 14.7px Calibri",
"themeFont":"Body",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":{
"color":"Accent 1 40",
"style":2
},
"name":"Heading 3",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"Text 2 0",
"font":"normal bold 14.7px Calibri",
"themeFont":"Body",
"name":"Heading 4"
},
{
"backColor":"#ffcc99",
"foreColor":"#3f3f76",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"borderLeft":{
"color":"#7f7f7f",
"style":1
},
"borderTop":{
"color":"#7f7f7f",
"style":1
},
"borderRight":{
"color":"#7f7f7f",
"style":1
},
"borderBottom":{
"color":"#7f7f7f",
"style":1
},
"name":"Input",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"#fa7d00",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":{
"color":"#ff8001",
"style":6
},
"name":"Linked Cell",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":"#ffeb9c",
"foreColor":"#9c6500",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Neutral"
},
{
"backColor":null,
"foreColor":"Text 1 0",
"hAlign":3,
"vAlign":2,
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":null,
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"Normal",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":"#ffffcc",
"borderLeft":{
"color":"#b2b2b2",
"style":1
},
"borderTop":{
"color":"#b2b2b2",
"style":1
},
"borderRight":{
"color":"#b2b2b2",
"style":1
},
"borderBottom":{
"color":"#b2b2b2",
"style":1
},
"name":"Note",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":"#f2f2f2",
"foreColor":"#3f3f3f",
"font":"normal bold 14.7px Calibri",
"themeFont":"Body",
"borderLeft":{
"color":"#3f3f3f",
"style":1
},
"borderTop":{
"color":"#3f3f3f",
"style":1
},
"borderRight":{
"color":"#3f3f3f",
"style":1
},
"borderBottom":{
"color":"#3f3f3f",
"style":1
},
"name":"Output",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"formatter":"0%",
"name":"Percent"
},
{
"backColor":null,
"foreColor":"Text 2 0",
"font":"normal bold 24px Calibri Light",
"themeFont":"Headings",
"name":"Title"
},
{
"backColor":null,
"foreColor":"Text 1 0",
"font":"normal bold 14.7px Calibri",
"themeFont":"Body",
"borderLeft":null,
"borderTop":{
"color":"Accent 1 0",
"style":1
},
"borderRight":null,
"borderBottom":{
"color":"Accent 1 0",
"style":6
},
"name":"Total",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"#ff0000",
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"name":"Warning Text"
},
{
"backColor":null,
"foreColor":"Text 1 0",
"hAlign":3,
"vAlign":2,
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"formatter":"General",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":null,
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInStyle1",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"Text 1 0",
"hAlign":3,
"vAlign":2,
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"formatter":"m/d/yyyy",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":null,
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInStyle2",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"Text 1 0",
"hAlign":3,
"vAlign":2,
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"formatter":"@",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":null,
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInStyle3",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"Text 1 0",
"hAlign":3,
"vAlign":2,
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"formatter":"0",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":null,
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInStyle4",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"Text 1 0",
"hAlign":3,
"vAlign":2,
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"formatter":"yyyy\\-mm\\-dd;@",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":null,
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInStyle5",
"diagonalDown":null,
"diagonalUp":null
},
{
"backColor":null,
"foreColor":"Text 1 0",
"hAlign":3,
"vAlign":2,
"font":"normal normal 14.7px Calibri",
"themeFont":"Body",
"formatter":"General",
"borderLeft":null,
"borderTop":null,
"borderRight":null,
"borderBottom":null,
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInStyle6",
"quotePrefix":true,
"diagonalDown":null,
"diagonalUp":null
},
{
"hAlign":3,
"vAlign":2,
"themeFont":"Body",
"formatter":"yyyy\\-mm\\-dd;@",
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInTableStyle0__builtInStyle5",
"diagonalDown":null,
"diagonalUp":null
},
{
"hAlign":3,
"vAlign":2,
"themeFont":"Body",
"formatter":"General",
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInTableStyle1__builtInStyle6",
"quotePrefix":true,
"diagonalDown":null,
"diagonalUp":null
},
{
"hAlign":3,
"vAlign":2,
"themeFont":"Body",
"formatter":"0",
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInTableStyle2__builtInStyle4",
"diagonalDown":null,
"diagonalUp":null
},
{
"hAlign":3,
"vAlign":2,
"themeFont":"Body",
"formatter":"@",
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInTableStyle3__builtInStyle3",
"diagonalDown":null,
"diagonalUp":null
},
{
"hAlign":3,
"vAlign":2,
"themeFont":"Body",
"formatter":"m/d/yyyy",
"locked":true,
"textIndent":0,
"wordWrap":false,
"name":"__builtInTableStyle4__builtInStyle2",
"diagonalDown":null,
"diagonalUp":null
}
]
}];
};
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Syntax
Argument
Description
time1
(Required) - shows the starting date and time from which we need to calculate elapsed time.
You can input the TIMEAGO function from the above code directly into a cell, or you can use the setFormula method to apply the formula.
Usage notes
The TIMEAGO function is meant to make it easier to calculate the time passed from a starting point to a current point in time
It's usage is mostly common on project management.
You can use the TIMEAGO function if you want to show something more relative to a specific time rather than a straightforward date.
Benefits
This function allows you to have a calculation of the interval passed between 2 moments without having to create complicated custom functions and methods.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
class TimeAgoFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("TIMEAGO", 1, 1);
}
evaluate(time1) {
switch (typeof time1) {
case 'number':
break;
case 'string':
time1 = +new Date(time1);
break;
case 'object':
if (time1.constructor === Date) time1 = time1.getTime();
break;
default:
time1 = +new Date();
}
let time2 = +new Date();
if (time1 == time2) {
return "just now";
}
var isFuture = (time2 < time1);
var seconds = (isFuture ? time1 - time2 : time2 - time1) / 1000;
var interval = seconds / 31536000;
if (interval >= 1) {
var years = Math.floor(interval);
return isFuture ? "in " + (years <= 1 ? "one year" : years + " years")
: years <= 1 ? "one year ago" : years + " years ago";
}
interval = seconds / 2592000;
if (interval >= 1) {
var months = Math.floor(interval);
return isFuture ? "in " + (months <= 1 ? "one month" : months + " months") : months <= 1 ? "one month ago" : months + " months ago";
}
interval = seconds / 86400;
if (interval >= 1) {
var days = Math.floor(interval);
return isFuture ? "in " + (days <= 1 ? "tomorrow" : days + " days")
: days <= 1 ? "yesterday" : days + " days ago";
}
interval = seconds / 3600;
if (interval > 1) {
var hours = Math.floor(interval);
return isFuture ? "in " + (hours <= 1 ? "an hour" : hours + " hours")
: hours <= 1 ? "an hour ago" : hours + " hours ago";
}
interval = seconds / 60;
if (interval > 1) {
var minutes = Math.floor(interval);
return isFuture ? "in " + (minutes <= 1 ? "a minute" : minutes + " minutes")
: minutes <= 1 ? "a minute ago" : minutes + " minutes ago";
}
seconds = Math.floor(seconds);
return isFuture ? "in " + (seconds <= 1 ? "one second" : seconds + " seconds")
: seconds <= 1 ? "one second ago" : seconds + " seconds ago";
}
}
const autoGenerateColumns = true;
export function AppFunc() {
const initSpread = (spread) => {
spread.suspendPaint();
const timeAgoFun = new TimeAgoFunction();
let sheet = spread.getSheet(0);
sheet.addCustomFunction(timeAgoFun);
sheet.setColumnWidth(0, 200);
sheet.setColumnWidth(1, 200);
sheet.setColumnWidth(2, 150);
sheet.setValue(0, 0, 'Date');
sheet.setValue(0, 1, 'Formula');
sheet.setValue(0, 2, 'Result');
sheet.setFormula(1, 0, 'TODAY()');
sheet.setValue(1, 1, '=TIMEAGO(A2)');
sheet.setFormula(1, 2, 'TIMEAGO(A2)');
sheet.setValue(2, 0, new Date('2020-01-20'));
sheet.setValue(2, 1, '=TIMEAGO(A3)');
sheet.setFormula(2, 2, 'TIMEAGO(A3)');
sheet.setValue(3, 0, new Date('2021-02-10'));
sheet.setValue(3, 1, '=TIMEAGO(A4)');
sheet.setFormula(3, 2, 'TIMEAGO(A4)');
sheet.setValue(4, 0, new Date('2021-11-29 17:12:00'));
sheet.setValue(4, 1, '=TIMEAGO(A5)');
sheet.setFormula(4, 2, 'TIMEAGO(A5)');
spread.resumePaint();
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet autoGenerateColumns={autoGenerateColumns}>
</Worksheet>
</SpreadSheets>
</div>
</div>;
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
class TimeAgoFunction extends GC.Spread.CalcEngine.Functions.Function {
constructor() {
super("TIMEAGO", 1, 1);
}
evaluate(time1) {
switch (typeof time1) {
case 'number':
break;
case 'string':
time1 = +new Date(time1);
break;
case 'object':
if (time1.constructor === Date) time1 = time1.getTime();
break;
default:
time1 = +new Date();
}
let time2 = +new Date();
if (time1 == time2) {
return "just now";
}
var isFuture = (time2 < time1);
var seconds = (isFuture ? time1 - time2 : time2 - time1) / 1000;
var interval = seconds / 31536000;
if (interval >= 1) {
var years = Math.floor(interval);
return isFuture ? "in " + (years <= 1 ? "one year" : years + " years")
: years <= 1 ? "one year ago" : years + " years ago";
}
interval = seconds / 2592000;
if (interval >= 1) {
var months = Math.floor(interval);
return isFuture ? "in " + (months <= 1 ? "one month" : months + " months") : months <= 1 ? "one month ago" : months + " months ago";
}
interval = seconds / 86400;
if (interval >= 1) {
var days = Math.floor(interval);
return isFuture ? "in " + (days <= 1 ? "tomorrow" : days + " days")
: days <= 1 ? "yesterday" : days + " days ago";
}
interval = seconds / 3600;
if (interval > 1) {
var hours = Math.floor(interval);
return isFuture ? "in " + (hours <= 1 ? "an hour" : hours + " hours")
: hours <= 1 ? "an hour ago" : hours + " hours ago";
}
interval = seconds / 60;
if (interval > 1) {
var minutes = Math.floor(interval);
return isFuture ? "in " + (minutes <= 1 ? "a minute" : minutes + " minutes")
: minutes <= 1 ? "a minute ago" : minutes + " minutes ago";
}
seconds = Math.floor(seconds);
return isFuture ? "in " + (seconds <= 1 ? "one second" : seconds + " seconds")
: seconds <= 1 ? "one second ago" : seconds + " seconds ago";
}
}
export class App extends Component {
constructor(props) {
super(props);
this.autoGenerateColumns = true;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet autoGenerateColumns={this.autoGenerateColumns}>
</Worksheet>
</SpreadSheets>
</div>
</div>;
}
initSpread(spread) {
spread.suspendPaint();
this.timeAgoFun = new TimeAgoFunction();
let sheet = spread.getSheet(0);
sheet.addCustomFunction(this.timeAgoFun);
sheet.setColumnWidth(0, 200);
sheet.setColumnWidth(1, 200);
sheet.setColumnWidth(2, 150);
sheet.setValue(0, 0, 'Date');
sheet.setValue(0, 1, 'Formula');
sheet.setValue(0, 2, 'Result');
sheet.setFormula(1, 0, 'TODAY()');
sheet.setValue(1, 1, '=TIMEAGO(A2)');
sheet.setFormula(1, 2, 'TIMEAGO(A2)');
sheet.setValue(2, 0, new Date('2020-01-20'));
sheet.setValue(2, 1, '=TIMEAGO(A3)');
sheet.setFormula(2, 2, 'TIMEAGO(A3)');
sheet.setValue(3, 0, new Date('2021-02-10'));
sheet.setValue(3, 1, '=TIMEAGO(A4)');
sheet.setFormula(3, 2, 'TIMEAGO(A4)');
sheet.setValue(4, 0, new Date('2021-11-29 17:12:00'));
sheet.setValue(4, 1, '=TIMEAGO(A5)');
sheet.setFormula(4, 2, 'TIMEAGO(A5)');
spread.resumePaint();
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);